uses Objects, Wizard, Dos;

Const JamSubBufSize = 4000;
 Processed: Longint = 0;

type
 JamSubBuffer = Array[1..JamSubBufSize] of Char;

 JamHdrType = record
  Signature: Array[1..4] of Char;
  Created: LongInt;
  ModCounter: LongInt;
  ActiveMsgs: LongInt;
  PwdCRC: LongInt;
  BaseMsgNum: LongInt;
  Extra: Array[1..1000] of Char;
 End;

 JamMsgHdrType = Record
  Signature: Array[1..4] of Char;
  Rev: Word;
  Resvd: Word;
  SubFieldLen: LongInt;
  TimesRead: LongInt;
  MsgIdCrc: LongInt;
  ReplyCrc: LongInt;
  ReplyTo: LongInt;
  ReplyFirst: LongInt;
  ReplyNext: LongInt;
  DateWritten: LongInt;
  DateRcvd: LongInt;
  DateArrived: LongInt;
  MsgNum: LongInt;
  Attr1: LongInt;
  Attr2: LongInt;
  TextOfs: LongInt;
  TextLen: LongInt;
  PwdCrc: LongInt;
  Cost: LongInt;
 End;

 HdrType = record
  JamHdr: JamMsgHdrType;
  SubBuf: JamSubBuffer;
 End;

 SubFieldType = Record
  LoId: Word;
  HiId: Word;
  DataLen: LongInt;
  Data: Array[1..1000] of Char;
 End;

 JamIdxType = Record
  MsgToCrc: LongInt;
  HdrLoc: LongInt;
 End;

 PMessage = ^TMessage;
 TMessage = object(TObject)
  Subj: PString;
  Date: Longint;
  Idx: JamIdxType;
  Times: Longint;
  constructor Init(ASubj: String; ADate: Longint; AIdx: JamIdxType; ATimes: Longint);
  destructor Done; virtual;
 end;

 PMessages = ^TMessages;
 TMessages = object(TSortedCollection)
  function Compare(key1, key2: pointer): integer; virtual;
 end;

function TMessages.Compare;
 var
  K1,K2: PMessage;
 begin
  K1:=Key1; K2:=Key2;
{  if K1^.Times<K2^.Times then Compare:=1 else
  if K1^.Times>K2^.Times then Compare:=-1 else}
  if K1^.Date<K2^.Date then Compare:=-1 else
  if K1^.Date>K2^.Date then Compare:=1 else
  if GetPString(K1^.Subj)<GetPString(K2^.Subj) then Compare:=-1 else
  if GetPString(K1^.Subj)>GetPString(K2^.Subj) then Compare:=1 else
  if K1^.Idx.HdrLoc<K2^.Idx.HdrLoc then Compare:=-1 else
  if K1^.Idx.HdrLoc>K2^.Idx.HdrLoc then Compare:=1 else
  if K1^.Idx.MsgToCrc<K2^.Idx.MsgToCrc then Compare:=-1 else
  if K1^.Idx.MsgToCrc>K2^.Idx.MsgToCrc then Compare:=1 else
   Compare:=0;
 end;

var
 Msgs: TMessages;

constructor TMessage.Init;
 begin
  inherited Init;
  Subj:=NewStr(ASubj);
  Date:=ADate;
  Idx.MsgToCrc:=AIdx.MsgToCrc;
  Idx.HdrLoc:=AIdx.HdrLoc;
  Times:=ATimes;
  if Times<>0 then Times:=1;
 end;

destructor TMessage.Done;
 begin
  DisposeStr(Subj);
  inherited Done;
 end;

procedure Scroller(M: Byte);
 const
  Scrollers: String[4] = '|/-\';
  Scroll: Integer = 0;
  Count: Integer = 0;
 begin
  if M=1 then
   begin
    Inc(Count);
    if Count<>10 then Exit;
    Count:=0;
   end;
  case M of
   1:
    begin
     Inc(Scroll);
     if Scroll>4 then Scroll:=1;
    end;
   2:
    begin
     Dec(Scroll);
     if Scroll<0 then Scroll:=4;
    end;
  end;
  Write(Scrollers[Scroll],#8);
 end;

procedure SortJam(FName: String);
 var
  F: TBufStream;
  I: TBufStream;
  H: JamHdrType;
  M: HdrType;
  S: Longint;
  SubPtr: ^SubFieldType;
  D: JamIdxType;
  MsgSubj, Tmp: String;
  Msg: PMessage;
  Cnt: Longint;
 procedure SaveIndex(M: PMessage); far;
  begin
   I.Write(M^.Idx,SizeOf(M^.Idx));
   Scroller(2);
  end;
 begin
  Tmp:=StUpcase(ForceExtension(JustFilename(FName),''));
  if Tmp[Byte(Tmp[0])]='.' then Dec(Tmp[0]);
  Write('Sorting '+Tmp);
  Msgs.Init(10,10);
  F.Init(ForceExtension(FName,'JHR'),stOpenRead,2048);
  if F.Status<>stOk then
   begin
    WriteLn(' error: cannot open JHR');
    Exit;
   end;
  H.Signature:='STF!';
  F.Read(H,SizeOf(H));
  if H.Signature<>'JAM'#0 then
   begin
    WriteLn(' error: wrong format.');
    Exit;
   end;
  I.Init(ForceExtension(FName,'JDX'),stOpen,2048);
  if I.Status<>stOk then
   begin
    WriteLn(' error: cannot open JDX');
    Exit;
   end;
  Cnt:=0;
  while (I.GetPos<>I.GetSize) and (I.GetPos<>-1) do
   begin
    I.Read(D,SizeOf(D));
    if D.HdrLoc=-1 then Continue;
    F.Seek(D.HdrLoc);
    if F.Status<>stOk then Continue;
    MsgSubj:='';
    F.Read(M,SizeOf(M));
    if M.JamHdr.Signature<>'JAM'#0 then Continue;
    Inc(Cnt);
    S:=1;
    while ((S<=M.JamHdr.SubFieldLen) and (S<JamSubBufSize)) do
     begin
      SubPtr:=@M.SubBuf[S];
      Inc(S, SubPtr^.DataLen+8);
      case SubPtr^.LoId of
       6:
        begin
         MsgSubj[0] := Chr(SubPtr^.DataLen and $ff);
         If Ord(MsgSubj[0]) > 100 Then MsgSubj[0] := #100;
         Move(SubPtr^.Data, MsgSubj[1], Ord(MsgSubj[0]));
        end;
      else
      end;
     end;
    Msg:=New(PMessage,Init(MsgSubj,M.JamHdr.DateWritten,D,M.JamHdr.TimesRead));
    Msgs.Insert(Msg);
    if Msgs.IndexOf(Msg)=-1 then Dispose(Msg,Done);
    Scroller(1);
   end;
  F.Done;
  Write(', saving');
  I.Seek(0);
  Msgs.ForEach(@SaveIndex);
  I.Done;
  Msgs.Done;
  Writeln(', done.');
  Inc(Processed);
 end;

var
 K: Byte;
 Sr: SearchRec;
 D: String;
begin
 WriteLn;
 WriteLn('JAMsort v0.1b, (c) by sk//MPG, 1998.');
 WriteLn;
 for K:=1 to ParamCount do
  begin
   D:=FExpand(ParamStr(K));
   FindFirst(D,AnyFile,Sr);
   while DosError=0 do
    begin
     if (Sr.Attr and Directory=0) and (JustExtension(Sr.Name)='JHR') then
      SortJam(AddBackSlash(JustPathName(D))+Sr.Name);
     FindNext(Sr);
    end;
  end;
 if Processed=0 then
  WriteLn('Nothing to do.')
 else
  WriteLn(Processed,' JAM(s) sorted.');
end.